'use strict';

var emotionUtils = require('emotion-utils');
var serialize = require('@emotion/serialize');

function _toString() {
  return "css-" + this.name;
}

function css(strings) {
  var stringMode = true;
  var styles = '';
  var identifierName = '';

  if (strings == null || strings.raw === undefined) {
    stringMode = false;
    styles += serialize.handleInterpolation.call(this, strings);
  } else {
    styles += strings[0];
  }

  for (var _len = arguments.length, interpolations = new Array(_len > 1 ? _len - 1 : 0), _key = 1; _key < _len; _key++) {
    interpolations[_key - 1] = arguments[_key];
  }

  interpolations.forEach(function (interpolation, i) {
    styles += serialize.handleInterpolation.call(this, interpolation);

    if (stringMode === true && strings[i + 1] !== undefined) {
      styles += strings[i + 1];
    }
  }, this);
  styles = styles.replace(serialize.labelPattern, function (match, p1) {
    identifierName += "-" + p1;
    return '';
  });
  var ret = {
    styles: styles,
    type: 1,

    get name() {
      delete this.name;
      this.name = emotionUtils.hashString(styles) + identifierName;
      return this.name;
    },

    toString: _toString
  };
  return ret;
}

module.exports = css;
//# sourceMappingURL=index.cjs.js.map
